'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' A ccsplitter library demo.
'
PROGRAM	"ccsplitterdemo"
VERSION	"0.0001"
MAKEFILE "pelles.xxx"
'
	IMPORT	"xst"   		' standard library	: required by most programs
	IMPORT  "xsx"				' extended std library
'	IMPORT	"xio"				' console io library
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT  "comctl32"	' comctl32.dll			: common controls library
'	IMPORT	"comdlg32"  ' comdlg32.dll	    : common dialog library
'	IMPORT	"xma"   		' math library			: Sin/Asin/Sinh/Asinh/Log/Exp/Sqrt...
'	IMPORT	"xcm"				' complex math library
	IMPORT  "msvcrt"		' msvcrt.dll				: C function library
'	IMPORT  "shell32"   ' shell32.dll

	IMPORT "CCSplitter.lib"
'
DECLARE FUNCTION Entry            ()
DECLARE FUNCTION WndProc          (hwnd, msg, wParam, lParam)
DECLARE FUNCTION InitGui          ()
DECLARE FUNCTION CreateWindows    ()
DECLARE FUNCTION NewWindow        (className$, titleBar$, style, x, y, w, h, exStyle)
DECLARE FUNCTION NewChild         (className$, text$, style, x, y, w, h, parent, id, exStyle)
DECLARE FUNCTION MessageLoop      ()
DECLARE FUNCTION CleanUp          ()
DECLARE FUNCTION GetNotifyMsg     (lParam, @hwndFrom, @idFrom, @code)
DECLARE FUNCTION CreateChildWindows (hParent)
DECLARE FUNCTION CCsplitter_GetHandle (hWnd, idView)
DECLARE FUNCTION CCsplitter_GetRect (hWnd, idView, lpRect)
DECLARE FUNCTION CCsplitter_GetSplit (hWnd, lpSplitX, lpSplitY)
DECLARE FUNCTION CCsplitter_SetHandle (hWnd, idView, hView) 
DECLARE FUNCTION CCsplitter_SetSplit (hWnd, lpSplitX, lpSplitY)

$$ID_SPLITTER	= 1000

$$IDS_SCCSID                     = 1
$$IDR_MAINMENU                   = 101
$$IDM_FILE_EXIT                  = 401
$$IDM_SPLIT_HORZ                 = 402
$$IDM_SPLIT_VERT                 = 403
$$IDM_SPLIT_WIDE                 = 404
$$IDM_HELP_ABOUT                 = 405
$$IDM_SPLIT_CONSTRAIN            = 406
$$IDM_SPLIT_SHOWPOS              = 407
$$IDM_SPLIT_SHOWWIDTH            = 408
$$IDM_SPLIT_SWAPVIEWS            = 409
'
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	STATIC	entry
'
	IF entry THEN RETURN							' enter once
	entry =  $$TRUE										' enter occured

'	XioCreateConsole (title$, 50)			' create console, if console is not wanted, comment out this line
	InitGui ()												' initialize program and libraries
	
  IF (!InitCCsplitter ()) THEN 
		MessageBoxA (0, &"InitCCsplitter failed in WinMain", 0, $$MB_ICONSTOP | $$MB_OK)
		QUIT (1)
	END IF
	
	IF CreateWindows () THEN QUIT (1)	' create windows and other child controls
	MessageLoop ()										' the main message loop
	CleanUp ()												' unregister all window classes
'	XioFreeConsole ()									' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
FUNCTION WndProc (hWnd, msg, wParam, lParam)

	PAINTSTRUCT ps
	RECT rc
	NMCCSPLIT spn
	CCSPLIT spx, spy
	SHARED hViewWnd[]
	SHARED hSplitter
	
	hMenu = GetMenu (hWnd)
	spx.cbSize = SIZE (spx)
  spy.cbSize = SIZE (spy)

	SELECT CASE msg

		CASE $$WM_CREATE : CreateChildWindows (hWnd)

		CASE $$WM_COMMAND :
			id = LOWORD (wParam)

			SELECT CASE id
		    CASE $$IDM_FILE_EXIT:
			    SendMessageA (hWnd, $$WM_CLOSE, 0, 0)

		    CASE $$IDM_SPLIT_HORZ:
			    GetClientRect (hSplitter, &rc)
			    ch = GetMenuState (hMenu, $$IDM_SPLIT_HORZ, 0) & $$MF_CHECKED
			    spx.flags  = $$CCSP_POS
					IF ch THEN spx.pos = 0 ELSE spx.pos = rc.right/2 
			    CCsplitter_SetSplit (hSplitter, &spx, NULL)

		    CASE $$IDM_SPLIT_VERT:
			    GetClientRect (hSplitter, &rc)
			    ch = GetMenuState (hMenu, $$IDM_SPLIT_VERT, 0) & $$MF_CHECKED
			    spy.flags  = $$CCSP_POS
					IF ch THEN spy.pos = 0 ELSE spy.pos = rc.bottom/2 
			    CCsplitter_SetSplit (hSplitter, NULL, &spy)

		    CASE $$IDM_SPLIT_WIDE:
			    ch = GetMenuState (hMenu, $$IDM_SPLIT_WIDE, 0) & $$MF_CHECKED
					IF ch THEN state = $$MF_UNCHECKED ELSE state = $$MF_CHECKED
					CheckMenuItem (hMenu, $$IDM_SPLIT_WIDE, state)
			    spx.flags  = $$CCSP_WIDTH
					spy.flags  = $$CCSP_WIDTH
					IF ch THEN w = 0 ELSE w = 15
					spx.width = w
					spy.width = w
			    CCsplitter_SetSplit (hSplitter, &spx, &spy)

		    CASE $$IDM_SPLIT_CONSTRAIN:
			    ch = GetMenuState (hMenu, $$IDM_SPLIT_CONSTRAIN, 0) & $$MF_CHECKED
					IF ch THEN state = $$MF_UNCHECKED ELSE state = $$MF_CHECKED
					CheckMenuItem (hMenu, $$IDM_SPLIT_CONSTRAIN, state)
			    spx.flags  = $$CCSP_LOWER | $$CCSP_UPPER
					spy.flags  = $$CCSP_LOWER | $$CCSP_UPPER
					IF ch THEN lower = 0 ELSE lower = 32
					spx.lower = lower
					spy.lower = lower
					IF ch THEN upper = 0 ELSE upper = 64
					spx.upper = upper
					spy.upper = upper
			    CCsplitter_SetSplit (hSplitter, &spx, &spy)

		    CASE $$IDM_SPLIT_SHOWPOS:
			    CCsplitter_GetSplit (hSplitter, &spx, &spy)
					str$ = NULL$(100)
			    sprintf (&str$, &"Splitter Position: x=%d y=%d", spx.pos, spy.pos)
			    MessageBoxA (hWnd, &str$, &"Info", $$MB_ICONINFORMATION | $$MB_OK)

		    CASE $$IDM_SPLIT_SHOWWIDTH:
			    CCsplitter_GetSplit (hSplitter, &spx, &spy)
					str$ = NULL$(100)
			    sprintf (&str$, &"Splitter Width: x=%d y=%d", spx.width, spy.width)
			    MessageBoxA (hWnd, &str$, &"Info", $$MB_ICONINFORMATION | $$MB_OK)

		    CASE $$IDM_SPLIT_SWAPVIEWS:
			    IF (CCsplitter_GetHandle (hSplitter, 0) == hViewWnd[0]) THEN 
						CCsplitter_SetHandle (hSplitter, 0, hViewWnd[4])
			    ELSE
						CCsplitter_SetHandle (hSplitter, 0, hViewWnd[0])
			    END IF 

		    CASE $$IDM_HELP_ABOUT:
			    MessageBoxA (hWnd, &"Non-MFC Splitter Control Example\n\nWritten by Roger Hnen\n\nOriginal code by Rob Pitt\n\nXBLite code by David Szafranski", &"About Splitter", $$MB_ICONINFORMATION | $$MB_OK)

			END SELECT

		CASE $$WM_DESTROY :
			PostQuitMessage(0)

		CASE $$WM_NOTIFY :
			idCtrl = wParam
			SELECT CASE idCtrl
				CASE $$ID_SPLITTER :
					GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)
					SELECT CASE code :
						CASE $$CCSPN_SPLITCHANGED:
							RtlMoveMemory (&spn, lParam, SIZE(spn))	
							IF spn.x THEN state = $$MF_CHECKED ELSE state = $$MF_UNCHECKED
							CheckMenuItem (GetMenu (hWnd), $$IDM_SPLIT_HORZ, state)
							IF spn.y THEN state = $$MF_CHECKED ELSE state = $$MF_UNCHECKED
							CheckMenuItem (GetMenu (hWnd), $$IDM_SPLIT_VERT, state)
 
					END SELECT
			END SELECT

'		CASE $$WM_PAINT :
'			hdc = BeginPaint (hWnd, &ps)
'			EndPaint (hWnd, &ps)

		CASE $$WM_SIZE :
			w = LOWORD (lParam)
			h = HIWORD (lParam)
			MoveWindow (hSplitter, 0, 0, w, h, 1)

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT

END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION InitGui ()

	SHARED hInst
	hInst = GetModuleHandleA (0) 	' get current instance handle
	IFZ hInst THEN QUIT (0)
	InitCommonControls ()					' initialize comctl32.dll library

END FUNCTION
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION CreateWindows ()

	SHARED hInst
	WNDCLASS wc

' register window class
	className$         = "TestCCSplitter"
	icon$ 			       = "scrabble"
	wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = &WndProc()
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, &icon$)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = NULL ' $$COLOR_BTNFACE + 1
	' note: porc resource compiler does not work on string menu names
	wc.lpszMenuName    = 100
	wc.lpszClassName   = &className$
	IFZ RegisterClassA (&wc) THEN RETURN ($$TRUE)

' create main window
	titleBar$ = "CCSplitter Test"
	style 		= $$WS_OVERLAPPEDWINDOW
	w 				= 320
	h 				= 300
	exStyle		= 0
	#winMain = NewWindow (@className$, @titleBar$, style, x, y, w, h, exStyle)
	IFZ #winMain THEN RETURN ($$TRUE)

	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)	' show window

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION NewWindow (className$, titleBar$, style, x, y, w, h, exStyle)

	SHARED hInst

	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION
'
'
' #########################
' #####  NewChild ()  #####
' #########################
'
FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

	SHARED hInst

	style = style | $$WS_CHILD | $$WS_VISIBLE
	RETURN CreateWindowExA (exStyle, &className$, &text$, style, x, y, w, h, parent, id, hInst, 0)

END FUNCTION
'
'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION MessageLoop ()

	MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN								' main program executes message loop

	DO																			' the message loop
		ret = GetMessageA (&msg, NULL, 0, 0)	' retrieve next message from queue

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam					' WM_QUIT message
			CASE -1 : RETURN $$TRUE							' error
			CASE ELSE:
				hwnd = GetActiveWindow ()
				IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN		' send only non-dialog messages
  				TranslateMessage (&msg)					' translate virtual-key messages into character messages
  				DispatchMessageA (&msg)					' send message to window callback function WndProc()
				END IF
		END SELECT
	LOOP

END FUNCTION
'
'
' ########################
' #####  CleanUp ()  #####
' ########################
'
FUNCTION CleanUp ()

	SHARED hInst, className$

	UnregisterClassA (&className$, hInst)

END FUNCTION
'
'
' #############################
' #####  GetNotifyMsg ()  #####
' #############################
'
FUNCTION GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)

	NMHDR nmhdr
	nmhdrAddr = lParam
'	XstCopyMemory (nmhdrAddr, &nmhdr, SIZE(nmhdr))	'Xsx library function
	RtlMoveMemory (&nmhdr, nmhdrAddr, SIZE(nmhdr))	'kernel32 library function
	hwndFrom = nmhdr.hwndFrom
	idFrom   = nmhdr.idFrom
	code     = nmhdr.code

END FUNCTION

FUNCTION CreateChildWindows (hParent)

	SHARED hSplitter
	SHARED hViewWnd[]
	SHARED hInst
	
	DIM hViewWnd[3]
	DIM viewTitles$[3]
	
	viewTitles$[0]  = "View 0"
  viewTitles$[1]  = "View 1"
  viewTitles$[2]  = "View 2"
  viewTitles$[3]  = "View 3"

 ' Create the splitter control

  hSplitter = CreateWindowExA (0,	&$$WC_CCSPLITTER, NULL, $$WS_CHILD | $$WS_VISIBLE, 0, 0, 0, 0, hParent, $$ID_SPLITTER, hInst, 0)

  IFZ hSplitter THEN 
		MessageBoxA (0, &"CreateWindowEx failed in CreateChildWindows", NULL, $$MB_ICONSTOP | $$MB_OK)
		QUIT (1)
	END IF 

  ' Create the View windows

  FOR i = 0 TO UBOUND(hViewWnd[])
		hViewWnd[i] = CreateWindowExA ($$WS_EX_CLIENTEDGE, &"EDIT", &viewTitles$[i], $$WS_CHILD | $$WS_VISIBLE, 0, 0, 0, 0, hParent, NULL, hInst, 0)

		IF (hViewWnd[i] == NULL) THEN 
	    MessageBoxA (0, &"CreateWindowEx failed in CreateChildWindows", NULL, $$MB_ICONSTOP | $$MB_OK)
	    QUIT (1)
		END IF 

		CCsplitter_SetHandle (hSplitter, i, hViewWnd[i])
  NEXT i

END FUNCTION

FUNCTION CCsplitter_GetHandle (hWnd, idView)
	SendMessageA (hWnd, $$CCSPM_GETHANDLE, idView, 0)
END FUNCTION 

FUNCTION CCsplitter_GetRect (hWnd, idView, lpRect)
  SendMessageA (hWnd, $$CCSPM_GETRECT, idView, lpRect)
END FUNCTION

FUNCTION CCsplitter_GetSplit (hWnd, lpSplitX, lpSplitY) 
  SendMessageA (hWnd, $$CCSPM_GETSPLIT, lpSplitX, lpSplitY)
END FUNCTION

FUNCTION CCsplitter_SetHandle (hWnd, idView, hView)
  SendMessageA (hWnd, $$CCSPM_SETHANDLE, idView, hView)
END FUNCTION

FUNCTION CCsplitter_SetSplit (hWnd, lpSplitX, lpSplitY)
  SendMessageA (hWnd, $$CCSPM_SETSPLIT, lpSplitX, lpSplitY)
END FUNCTION

END PROGRAM
